require "gr1"
require "slider"

--[[=====================================================]]
--[[=====================================================]]
function globals()
  
  
  sp1  = 0.4 
  sp2  = 0.2 
  sp3  = 0.1

  cred  = 0.1
  cgre  = 0.3
  cblu  = 0.8 

  ---------------------- reload saved values ------------
  k = {}
  loadFile()
  default()
  -------------------------------------------------------
  
  -------- need for show me ------
  image = love.graphics.newImage( "me.png" )  
  showMeFlag = false  
  mp1 = 0
  mp2 = 0  
  --------------------------------
  
  --------------------------------
  -- button1  test flag
  --------------------------------
  TestFlag  = false
  B1mp1 = 0
  B1mp2 = 0  
  --------------------------------
  
  t={}
  love.conf(t)
  
  print (t.author)
  
  gr = love.graphics 
  
  GrModes={}
  GrModes = gr.getModes()
  mw,mh, fullscreen, vsync, fsaa = love.graphics.getMode( )
  vsync = 1  fsaa = 1
  love.graphics.getMode(mw,mh, fullscreen, vsync, fsaa )
  screenmode = 0
  
  gr.setBackgroundColor(cred*255,cgre*255,cblu*255)

  
  smx = 700  smy = 700
  love.graphics.setMode( smx, smy, 0, 0, 0 )  
       
  --smxh = smx/2  smyh = smy/2
  smxh = smx/2  smyh = 300
       
       
       
  love.mouse.setVisible(true) 
  mx = 0
  my = 0
  
  volume = 0.1
  volumeGenerale = 1
  volumeGeneraleH = 1  
  
  
  saveString=""
  
  beep1(1,1)
  
  --bit = require"bit"
  
  Clean = true
  
end
--[[=====================================================]]
--[[=====================================================]]
function love.keypressed(key)
  if key == 'escape' then
      love.event.quit()
   end
  if key == ' ' then
      Clean = not Clean
   end
end
--[[=====================================================]]
--[[=====================================================]]
function beep1(ind,volp)
  
  if volp == nil then
    volp = 0.1
  end
  
  if(sound1) then sound1:stop() end
  
  if ind == 0 then
  elseif ind == 1 then
    sound1 = love.audio.newSource("beep600h50ms.ogg")   
  end
  
  local vol = volp * volumeGenerale
  sound1:setVolume(vol)
  if not noSound then sound1:play() end
  
end

--[[=====================================================]]
--[[=====================================================]]
function love.mousereleased(x, y, button)
   if button == "l" then
      mouseGrabbed = 0
      --printx = x
      --printy = y
   end
end

--[[=====================================================]]
--[[=====================================================]]
function distance(x1,y1,x2,y2)
  local d1,d2,d
  d1 = x1-x2  d2 = y1-y2
  d = math.sqrt(d1*d1 + d2*d2)
  return d
end


--[[=====================================================]]
--[[=====================================================]]
function show_me(sx,sy,lx,ly)
  local r,g,b,a
  r,g,b,a = gr.getColor()
  local x,y
  x,y = love.mouse.getPosition()
  gr.circle("line",sx+lx/2,sy+ly/2,lx/2,20)
  gr.print("me",sx+2,sy+2)
  if (x>=sx) and (x<=(sx+lx)) and (y>=sy) and (y<=(sy+ly)) then  
    gr.setColor(200,0,0,255)
    gr.circle("line",sx+lx/2,sy+ly/2,lx/2,20)
    if love.mouse.isDown("l") then mp1 = 1  else  mp1 = 0  end
  end      
  if mp2 ~= mp1  then
      mp2 = mp1
      if mp1 == 1 then  showMeFlag = not showMeFlag end
  end
  gr.setColor(r,g,b,a)
end



--[[=====================================================]]
--[[=====================================================]]
function ButtonTest(sx,sy,lx,ly)
  local r,g,b,a
  r,g,b,a = gr.getColor()
  local x,y
  x,y = love.mouse.getPosition()
  gr.circle("line",sx+lx/2,sy+ly/2,lx/2,20)
  gr.print("test",sx+2,sy+2)
  if (x>=sx) and (x<=(sx+lx)) and (y>=sy) and (y<=(sy+ly)) then  
    gr.setColor(200,0,0,255)
    gr.circle("line",sx+lx/2,sy+ly/2,lx/2,20)
    if love.mouse.isDown("l") then B1mp1 = 1  else  B1mp1 = 0  end
  end      
  if B1mp2 ~= B1mp1  then
      B1mp2 = B1mp1
      if B1mp1 == 1 then  TestFlag = not TestFlag end
  end
  gr.setColor(r,g,b,a)
end
--[[=====================================================]]
--[[=====================================================]]
function restoreK()
  print("restoreK")
  ---------------------- restore ---------------
  cred = k["red"]/100
  cgre = k["gre"]/100
  cblu = k["blu"]/100
  
  sp1 = k["sp1"]/100
  sp2 = k["sp2"]/100
  sp3 = k["sp3"]/100
  
  volumeGenerale =  k["volume"]/100
  -----------------------------------------------
end
--[[=====================================================]]
--[[=====================================================]]
function setK()
  print("setK")
  ---------------------- restore ---------------
  k["red"] = math.floor(cred*100)
  k["gre"] = math.floor(cgre*100)
  k["blu"] = math.floor(cblu*100)
  
  k["sp1"] = math.floor(sp1*100)
  k["sp2"] = math.floor(sp2*100)
  k["sp3"] = math.floor(sp3*100)
  
  k["volume"] =  math.floor(volumeGenerale*100)
  -----------------------------------------------
end
--[[=====================================================]]
--[[=====================================================]]
function default()
  print("default")
  
  if k["red"] == nil then k["red"] = 10 end
  if k["gre"] == nil then k["gre"] = 70 end
  if k["blu"] == nil then k["blu"] = 90 end
  
  if k["sp1"] == nil then k["sp1"] = 50 end
  if k["sp2"] == nil then k["sp2"] = 40 end
  if k["sp3"] == nil then k["sp3"] = 20 end
  
  if k["volume"] == nil then  volumeGenerale = 0.5 k["volume"] = math.floor(volumeGenerale * 100) end
  
  restoreK()
  
  save()
  
end
--[[=====================================================]]
--[[=====================================================]]
function save()
  print("save")
  setK()
  saveString = ""
  for i,v in pairs(k) do 
    saveString = saveString..i.." "..v.."\r\n"
  end  
end
--[[=====================================================]]
--[[=====================================================]]
function love.quit()
  save()
  print("Thanks for playing. Please play again soon!")
  love.filesystem.write( "data.txt", saveString,string.len(saveString))  
end

--[[=====================================================]]
--[[=====================================================]]

function loadFile()
  print("loadFile")
  
  local contents = ""
  local bool =  love.filesystem.exists( "data.txt")
  if  not bool then
    default()
    contents = "volume 50"
    local lx = string.len(contents)
    love.filesystem.write( "data.txt", contents,lx)  
  end
    
    
  contents, size = love.filesystem.read( "data.txt", 10000 )  
  -- then save to old file
  love.filesystem.write( "data-old.txt", contents,string.len(contents))  
  
  local t1={}
  contents:gsub("(%w+)", function(w) table.insert(t1,w) end)
  local a,b
  for i,v in ipairs(t1) do 
    a = b
    b = v
    if(i>1) and ((i % 2)==0) then k[a]=b end
  end
  restoreK()

end
--[[=====================================================]]
--[[=====================================================]]

function love.mousepressed()
  if Clean == true then Clean = false end
end
